using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace PropertyNamesGenerator.CodeGenerator
{
    public class CSharpCodeFileGenerator : CodeFileGenerator
    {
        public CSharpCodeFileGenerator(string className, string fileName): base(className, fileName)
        {
        }


        protected override string GetFileExtension()
        {
            return "cs";
        }

        public override void WriteHeader()
        {
            WriteHeader("//");
        }

        public override void WriteNamespace()
        {
            Writer.WriteLine("namespace GeneratedPropertyNames");
            Writer.WriteLine("{");
        }


        public override void CreateAccessClass(string className, string generatedClassName)
        {
            Writer.WriteLine("\tpublic partial class PropertyNames");
            Writer.WriteLine("\t{");
            Writer.WriteLine(string.Format("\t\tpublic static readonly {0} {1} = new {0}();", generatedClassName, className));
            Writer.WriteLine("\t}");
            Writer.WriteLine();
        }

        public override void CreateInternalClass(string generatedClassName, List<string> properties)
        {
            Writer.WriteLine(string.Format("\tpublic class {0}", generatedClassName));
            Writer.WriteLine("\t{");
            foreach (string property in properties)
            {
                Writer.WriteLine(string.Format("\t\tpublic readonly string {0} = \"{0}\";", property));
            }
            Writer.WriteLine("\t}");
            Writer.WriteLine();
        }


        public override void FinalizeGeneration()
        {
            Writer.WriteLine("}");
            base.FinalizeGeneration();
        }

    }
}
