using System;
using System.Collections.Generic;
using System.Text;

namespace PropertyNamesGenerator.CodeGenerator
{
    public class CodeFileGeneratorFactory
    {
        public static CodeFileGenerator CreateGenerator(string className, string fileName, Language language)
        {
            if (language == Language.CSharp)
                return new CSharpCodeFileGenerator(className, fileName);
            else if (language == Language.VB)
                return new VBCodeFileGenerator(className, fileName);
            else
                throw new Exception("No generator found.");
            
        }
    }
}
