using System;
using System.Collections.Generic;
using System.Text;

namespace PropertyNamesGenerator.CodeGenerator
{
    public class VBCodeFileGenerator : CodeFileGenerator
    {
        public VBCodeFileGenerator(string className, string fileName) : base(className, fileName)
        {
        }


        protected override string GetFileExtension()
        {
            return "vb";
        }


        public override void WriteHeader()
        {
            WriteHeader("'");
        }

        public override void WriteNamespace()
        {
            Writer.WriteLine("Namespace GeneratedPropertyNames");
            Writer.WriteLine("");
        }


        public override void CreateAccessClass(string className, string generatedClassName)
        {
            Writer.WriteLine("\tPartial Public Class PropertyNames");
            Writer.WriteLine("");
            Writer.WriteLine(string.Format("\t\tPublic Shared ReadOnly {1} As {0}", generatedClassName, className));
            Writer.WriteLine("");
            Writer.WriteLine("\tEnd Class");
            Writer.WriteLine();
        }

        public override void CreateInternalClass(string generatedClassName, List<string> properties)
        {
            Writer.WriteLine(string.Format("\tPublic Class {0}", generatedClassName));
            Writer.WriteLine("\t");
            foreach (string property in properties)
            {
                Writer.WriteLine(string.Format("\t\tPublic ReadOnly {0} As String  = \"{0}\"", property));
            }
            Writer.WriteLine("\t");
            Writer.WriteLine("\tEnd Class");
        }


        public override void FinalizeGeneration()
        {
            Writer.WriteLine("");
            Writer.WriteLine("End Namespace");
            base.FinalizeGeneration();
        }
    }
}
