using System;
using System.Collections.Generic;
using System.IO;
using System.Reflection;
using System.Text;

namespace PropertyNamesGenerator.Util
{
    internal class DirectoryUtil
    {
        /// <summary>
        /// Set current directory relative to assembly directory
        /// Directory must be either absolute or relative to program path
        /// </summary>
        /// <param name="directory">directory</param>
        internal static void SetCurrentDirectory(string directory)
        {
            Output.NotifyUser("Setting current directoy to " + directory, OutputLevel.Info);

            //Reset directory to assembly dir
            Directory.SetCurrentDirectory(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location));

            Directory.SetCurrentDirectory(directory);
        }

    }
}
