using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using PropertyNamesGenerator.Util;

namespace PropertyNamesGenerator
{
    internal class Validator
    {
        internal static bool ValidateProgramInput(string inputDir, string searchString, string outputDir)
        {
            bool result = CheckAllArgumentsHaveBeenSpecified(inputDir, searchString, outputDir);

            result &= CheckDirectoryExistence(inputDir);
            result &= CheckDirectoryExistence(outputDir);
            return result;

            return result;           
        }

        private static bool CheckAllArgumentsHaveBeenSpecified(string inputDir, string searchString, string outputDir)
        {
            if (string.IsNullOrEmpty(inputDir))
                Output.NotifyUser("Could not parse input dir from arguments", OutputLevel.Error);
            if (string.IsNullOrEmpty(searchString))
                Output.NotifyUser("Could not parse searchString from arguments", OutputLevel.Error);
            if (string.IsNullOrEmpty(outputDir))
                Output.NotifyUser("Could not parse outputDir from arguments", OutputLevel.Error);

            if (string.IsNullOrEmpty(inputDir) || string.IsNullOrEmpty(inputDir) || string.IsNullOrEmpty(inputDir))
                return false;
            return true;
        }

        /// <summary>
        /// Check if directory exists. 
        /// </summary>
        /// <param name="outputDir">directory</param>
        /// <returns>if directory is valid</returns>
        private static bool CheckDirectoryExistence(string outputDir)
        {
            try
            {
                string oldDir = Directory.GetCurrentDirectory();
                DirectoryUtil.SetCurrentDirectory(outputDir);
                return (oldDir != Directory.GetCurrentDirectory());
            }
            catch
            {
                return false;
            }

        }
    }
}
